﻿Imports System.IO

Public Class MainFrm

    Dim RTB As New RichTextBox
    Dim PicBox As New PictureBox

    'Enum is not neccesary at this point 
    'but included just in case
    Private Enum clipContains
        Text = 0
        Image = 1
        Audio = 2
        File_Drop_List = 3
        Other = 4
    End Enum
    Private Sub SelectDataType()

        Dim ClipType As String = ""
        Dim clipcontent As clipContains = Nothing

        Select Case True

            Case My.Computer.Clipboard.ContainsFileDropList

                ClipType = "Drop List"
                clipcontent = clipContains.File_Drop_List
                Call AddRichTextBox()
                Call SetDropEffect()

            Case My.Computer.Clipboard.ContainsImage

                ClipType = "Image"
                clipcontent = clipContains.Image
                Call AddPictureBox()

            Case My.Computer.Clipboard.ContainsAudio

                ClipType = "Audio"
                clipcontent = clipContains.Audio

            Case My.Computer.Clipboard.ContainsText

                ClipType = "Text"
                clipcontent = clipContains.Text
                Call AddRichTextBox()
                RTB.Text = My.Computer.Clipboard.GetText()

            Case Else

                ClipType = "Unknown"
                clipcontent = clipContains.Other
                Call AddRichTextBox()

        End Select


    End Sub

    Private Sub SetDropEffect()

        Dim DropType As String = Nothing
        Dim DropEffType As String = ""
        Dim DropEffNum As Integer = 0
        Dim DropEff As System.Windows.Forms.DragDropEffects = Nothing

        If My.Computer.Clipboard.ContainsFileDropList() Then

            'Get Drop Effects
            Dim DropEffectData(3) As Byte
            Dim DropEffectCheck As Object = My.Computer.Clipboard.GetData("Preferred DropEffect")
            DropEffectCheck.Read(DropEffectData, 0, DropEffectData.Length)
            Select Case DropEffectData(0)
                Case 2
                    DropEff = DragDropEffects.Move
                    DropEffType = "Move"
                Case 5
                    DropEff = DragDropEffects.Copy
                    DropEffType = "Copy"
                Case Else
                    DropEffType = "Unknown"
            End Select
            DropEffNum = DropEffectData(0).ToString
            DropType = String.Concat(DropEffNum, " - ", DropEffType)

            'Get File names from the file drop list
            Call GetFileNames()

        End If

    End Sub
    Private Sub GetFileNames()

        Dim FileNameCollection As Collections.Specialized.StringCollection = My.Computer.Clipboard.GetFileDropList()
        Dim tmpStr As String = Nothing
        For Each FileName As String In FileNameCollection
            tmpStr = String.Concat(tmpStr, FileName, vbCr)
        Next

        RTB.Text = tmpStr

    End Sub

    Private Sub MainFrm_Load _
        (ByVal sender As System.Object, _
         ByVal e As System.EventArgs) _
     Handles MyBase.Load
        SelectDataType()

    End Sub

    Private Sub AddRichTextBox()

        PicBox.Visible = False
        RTB.Font = MyBase.Font 'To force the Segoe UI Font style
        viewPanel.Controls.Add(RTB)
        RTB.Dock = DockStyle.Fill
        RTB.Show()

    End Sub

    Private Sub AddPictureBox()

        RTB.Visible = -False
        Dim img As Image = My.Computer.Clipboard.GetImage()
        PicBox.Image = Nothing
        viewPanel.Controls.Add(PicBox)
        PicBox.BackgroundImage = img
        PicBox.BackgroundImageLayout = ImageLayout.Stretch
        PicBox.Dock = DockStyle.Fill
        PicBox.Show()

    End Sub

    Private Sub ClearTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearTSBUT.Click

        My.Computer.Clipboard.Clear()
        RTB.Clear()
        PicBox.BackgroundImage = Nothing

    End Sub

    Private Sub TextTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextTSBUT.Click
        Call AddRichTextBox()
    End Sub

    Private Sub FileListTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileListTSBUT.Click
        Call AddRichTextBox()
    End Sub

    Private Sub OtherTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OtherTSBUT.Click
        Call AddRichTextBox()
    End Sub

    Private Sub ImageTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImageTSBUT.Click
        Call AddPictureBox()
    End Sub

    Private Sub ForAudio()

        Dim fs As Stream = My.Computer.Clipboard.GetAudioStream

        Try
            Dim strRead As StreamReader = New StreamReader(fs)
            Dim str As String = strRead.ReadToEnd()
        Catch ex As Exception

        End Try
      
    End Sub

    Private Sub AudioTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AudioTSBUT.Click

        Call ForAudio()

    End Sub

    Private Sub SaveTSBUT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveTSBUT.Click

        Dim str As String = RTB.Text
        My.Computer.Clipboard.SetText(str)

    End Sub

End Class

